#!/usr/bin/env python3
# encoding: utf-8
#
# This file is a part of the LinkAhead Project.
#
# Copyright (C) 2024 Indiscale GmbH <info@indiscale.com>
# Copyright (C) 2024 Henrik tom Wörden <h.tomwoerden@indiscale.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.

import os
import tempfile

from caosadvancedtools.table_json_conversion.fill_xlsx import (
    _get_path_rows, _get_row_type_column, fill_template)
from openpyxl import load_workbook


def rfp(*pathcomponents):
    """
    Return full path.
    Shorthand convenience function.
    """
    return os.path.join(os.path.dirname(__file__), *pathcomponents)


def test_detect():
    example = load_workbook(rfp("example_template.xlsx"))
    assert 1 == _get_row_type_column(example['Person'])
    assert [2,3,4] == _get_path_rows(example['Person'])

def test_fill_xlsx():
    path = os.path.join(tempfile.mkdtemp(), 'test.xlsx')
    assert not os.path.exists(path)
    fill_template(rfp('example_template.xlsx'), rfp('example.json'), path )
    assert os.path.exists(path)
    generated = load_workbook(path)  # workbook can be read
